﻿Namespace System.Runtime.CompilerServices

   Public Class WeakAttachBase2(Of TKey As Class, Tself As {WeakAttachBase2(Of TKey, Tself), New})

      Private Shared ReadOnly _IListFields As New ConditionalWeakTable(Of TKey, Tself)

      Private Shared creater As ConditionalWeakTable(Of TKey, Tself).CreateValueCallback = _
         Function(k) New Tself With {._Key = k}


      Protected _Key As TKey

      Public Shared Function GetAttached(ByVal key As TKey) As Tself
         Return _IListFields.GetValue(key, creater)
      End Function

   End Class

   Public Class WeakAttachBase(Of TKey As Class, Tself As {WeakAttachBase(Of TKey, Tself), New})

      Private Shared ReadOnly _IListFields As New ConditionalWeakTable(Of Object, Tself)

      Private Shared creater As ConditionalWeakTable(Of Object, Tself).CreateValueCallback = _
         Function(k) New Tself With {._Key = (DirectCast(k, TKey))}


      Protected _Key As TKey

      Public Shared Function GetAttached(ByVal key As Object) As Tself
         Return _IListFields.GetValue(key, creater)
      End Function

   End Class

End Namespace
